# all my home stuff :3
sysConf: { config, pkgs, lib, ... }:
{
	home.sessionVariables = {
		# system configuration
		EDITOR = "nvim";

		# cleanup homedir
		CARGO_HOME = "${config.xdg.dataHome}/cargo";

		# fish config
		fish_greeting = "✨️ heya ${sysConf.user}, welcome to ${sysConf.prettyHost} ~";
	};
	# installing my packages uvu
	home.packages = with pkgs; [
		bat
		diceware
		pwgen
		kitty
		schildichat-desktop
		dino
		mangohud
		termpdfpy
		lollypop
		skim
		syncthing
		armcord
		ripgrep
		tmate
		btop
		firefox
		apostrophe
		warp
		syncplay
		mpv
		wl-clipboard
		adw-gtk3
	# some bullshit to get gnome apps to install withotu a prefix
	] ++ (with pkgs.gnome; with pkgs.gnomeExtensions; [
		gnome-tweaks
		dconf-editor
		night-theme-switcher
		rounded-window-corners
		appindicator
	]);

	# configure programs
	programs.home-manager.enable = true;
	programs.fish = {
		enable = true;
		shellAbbrs = {
			nxs = "nix search nixpkgs";
			nxr = "nix run nixpkgs#";
			nxsh = "nix shell nixpkgs#";
			e = "edit";
			nxb = "sudo nixos-rebuild switch";
			nxu = "sudo nixos-rebuild boot --upgrade";
			nxc = "sudo nix-collect-garbage -d";
		};
		interactiveShellInit = ''
fish_add_path ~/.local/bin
fish_add_path ~/.local/bin/scripts
fish_add_path ~/.local/share/cargo/bin
fish_add_path /var/lib/flatpak/exports/bin
fish_vi_key_bindings
'';
	};
	programs.password-store = {
		enable = true;
		package = pkgs.pass.withExtensions (exts: [ exts.pass-otp ]);
		settings = { 
			PASSWORD_STORE_DIR = "${config.xdg.dataHome}/pass";
			PASSWORD_STORE_CLIP_TIME = "60";
		};
	};
	programs.browserpass.enable = true;
	programs.gpg.enable = true;

	# don't uh, change this or something might break lol idk
	home.stateVersion = "22.11";
}
